AAR = {
	Layout = {
		TitleBarHeight = 33,
		SubTitleBarHeight = 31,
		SubTitleBannerWidth = 180,
		SubTitleCapWidth = 20,
		FooterHeight = 38,
		Width = 800,
		Height = 490
	},
	Scoreboard = {
		Layout = {
			Height = 614
		},
		NumRows = 18
	},
	Arrow = {
		Width = 32,
		Height = 64
	},
	Progress = {
		Layout = {
			Height = 453
		}
	},
	NumUnlocksPerPage = 3,
	Swatch = {
		title = Colors.primary_text_color,
		title_2 = Colors.secondary_text_color,
		background = Colors.grey_14,
		background_2 = Colors.grey_22,
		background_3 = Colors.grey_4,
		background_4 = {
			r = 0.12,
			g = 0.12,
			b = 0.12
		},
		background_5 = Colors.very_dark_cyan,
		trim = Colors.grey_4,
		subtext = Colors.grey_4,
		colorpop = Colors.frontend_hilite,
		progressborder = Colors.white,
		header_text = Colors.white,
		spacer_1 = Colors.grey_2,
		friendly = Colors.cyan,
		enemy = Colors.orange,
		border = Colors.window_border_color
	}
}
AwardsTable = {
	File = "mp/awardTable.csv",
	Cols = {
		Ref = 1,
		Icon = 2,
		Name = 3,
		Desc = 4
	}
}
FactionTable = {
	File = "mp/factionTable.csv",
	Cols = {
		Ref = 0,
		ColorRed = 14,
		ColorGreen = 15,
		ColorBlue = 16
	}
}
AAR.GetFactionColorRed = function ( f1_arg0 )
	return Engine.TableLookup( FactionTable.File, FactionTable.Cols.Ref, f1_arg0, FactionTable.Cols.ColorRed )
end

AAR.GetFactionColorGreen = function ( f2_arg0 )
	return Engine.TableLookup( FactionTable.File, FactionTable.Cols.Ref, f2_arg0, FactionTable.Cols.ColorGreen )
end

AAR.GetFactionColorBlue = function ( f3_arg0 )
	return Engine.TableLookup( FactionTable.File, FactionTable.Cols.Ref, f3_arg0, FactionTable.Cols.ColorBlue )
end

AAR.GetRoundSquadMember = function ( f4_arg0 )
	return Engine.GetPlayerDataEx( f4_arg0, CoD.StatsGroup.Common, "round", "squadMemberIndex" )
end

AAR.GetRoundOperationsXP = function ( f5_arg0 )
	return Engine.GetPlayerDataEx( f5_arg0, CoD.StatsGroup.Common, "round", "operationXp" ) or 0
end

AAR.GetRoundMatchXP = function ( f6_arg0 )
	return Engine.GetPlayerDataEx( f6_arg0, CoD.StatsGroup.Common, "round", "matchXp" ) or 0
end

AAR.GetRoundMiscXP = function ( f7_arg0 )
	return Engine.GetPlayerDataEx( f7_arg0, CoD.StatsGroup.Common, "round", "miscXp" ) or 0
end

AAR.GetRoundScoreXP = function ( f8_arg0 )
	return Engine.GetPlayerDataEx( f8_arg0, CoD.StatsGroup.Common, "round", "scoreXp" ) or 0
end

AAR.GetRoundChallengeXP = function ( f9_arg0 )
	return Engine.GetPlayerDataEx( f9_arg0, CoD.StatsGroup.Common, "round", "challengeXp" ) or 0
end

AAR.GetRoundDoubleXP = function ( f10_arg0 )
	return Engine.GetPlayerDataReservedInt( f10_arg0, CoD.StatsGroup.Common, "common_entitlement_xp" ) or 0
end

AAR.GetRoundClanXP = function ( f11_arg0 )
	return Engine.GetPlayerDataReservedInt( f11_arg0, CoD.StatsGroup.Common, "common_clan_wars_xp" ) or 0
end

AAR.GetTotalUnlockPoints = function ( f12_arg0 )
	return Engine.GetPlayerDataEx( f12_arg0, CoD.StatsGroup.Ranked, "unlockPoints" ) or 0
end

AAR.GetRoundTotalXP = function ( f13_arg0 )
	return Engine.GetPlayerDataEx( f13_arg0, CoD.StatsGroup.Common, "round", "totalXp" ) or 0
end

AAR.GetCareerExperienceForSquadMember = function ( f14_arg0, f14_arg1 )
	return Engine.GetPlayerDataEx( f14_arg0, CoD.StatsGroup.Ranked, "squadMembers", f14_arg1, "squadMemXP" ) or 0
end

AAR.GetNumAwards = function ( f15_arg0 )
	return Engine.GetPlayerDataEx( f15_arg0, CoD.StatsGroup.Common, "round", "awardCount" )
end

AAR.GetAccolade = function ( f16_arg0, f16_arg1 )
	return Engine.GetPlayerDataEx( f16_arg0, CoD.StatsGroup.Common, "round", "awards", f16_arg1, "award" )
end

AAR.GetAwardIcon = function ( f17_arg0 )
	return Engine.TableLookup( AwardsTable.File, AwardsTable.Cols.Ref, f17_arg0, AwardsTable.Cols.Icon )
end

AAR.GetAwardName = function ( f18_arg0 )
	return Engine.TableLookup( AwardsTable.File, AwardsTable.Cols.Ref, f18_arg0, AwardsTable.Cols.Name )
end

AAR.GetAwardDesc = function ( f19_arg0 )
	return Engine.TableLookup( AwardsTable.File, AwardsTable.Cols.Ref, f19_arg0, AwardsTable.Cols.Desc )
end

AAR.AreChaosStats = function ( f20_arg0 )
	if not Engine.IsAliensMode() then
		return false
	elseif f20_arg0 == "mugger" then
		return true
	else
		return false
	end
end

