Leaderboards.Layout = {
	HeaderHeight = 45,
	SubtitleBannerWidth = 600,
	NumRows = 18,
	RowHeight = 26,
	Width = 1150,
	FilterWidth = 500,
	FilterHeight = 200
}
Leaderboards.DurationDefs = {
	Alltime = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_ALLTIME",
		Duration = "TRK_ALLTIME"
	},
	Weekly = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_WEEKLY",
		Duration = "TRK_WEEKLY"
	},
	Monthly = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_MONTHLY",
		Duration = "TRK_MONTHLY"
	},
	PrestigeAlltime = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_PRESTIGE_ALLTIME",
		Duration = "TRK_PRESTIGE_ALLTIME"
	},
	PrestigeWeekly = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_PRESTIGE_WEEKLY",
		Duration = "TRK_PRESTIGE_WEEKLY"
	},
	PrestigeMonthly = {
		OptionText = "@LUA_MENU_LB_FILTER_DURATION_PRESTIGE_MONTHLY",
		Duration = "TRK_PRESTIGE_MONTHLY"
	}
}
Leaderboards.Filters = {
	None = {
		Title = "@LUA_MENU_GHOSTS_LEADERBOARD_ALL_CAPS",
		OptionText = "@LUA_MENU_LB_FILTER_GROUP_ALL",
		Value = "none"
	},
	Friends = {
		Title = "@LUA_MENU_GHOSTS_LEADERBOARD_FRIENDS_CAPS",
		OptionText = "@LUA_MENU_LB_FILTER_GROUP_FRIENDS",
		Value = "friends"
	},
	FacebookFriends = {
		Title = "@LUA_MENU_GHOSTS_LEADERBOARD_FACEBOOKFRIENDS_CAPS",
		OptionText = "@LUA_MENU_LB_FILTER_GROUP_FACEBOOKFRIENDS",
		Value = "facebook_friends"
	},
	LobbyMembers = {
		Title = "@LUA_MENU_GHOSTS_LEADERBOARD_LOBBY_CAPS",
		OptionText = "@LUA_MENU_LB_FILTER_GROUP_LOBBY_MEMBERS",
		Value = "lobby_members"
	},
	Clan = {
		Title = "@LUA_MENU_GHOSTS_LEADERBOARD_CLAN_CAPS",
		OptionText = "@LUA_MENU_LB_FILTER_GROUP_CLAN",
		Value = "clan"
	}
}
Leaderboards.Boards = {
	Common = {
		NumColumns = 3,
		HeaderNames = {
			"@LUA_MENU_RANK_CAPS",
			"@LUA_MENU_LEVEL_CAPS",
			"@LUA_MENU_PLAYER_NAME_CAPS"
		},
		ColumnWidths = {
			100,
			63,
			310
		},
		DataColumnIndexes = {
			0,
			1,
			3
		}
	},
	Score = {
		NumColumns = 4,
		Title = "@LUA_MENU_SCORE_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_TOTALXP_AT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_TOTALXP_LT",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_TOTALXP_LT",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_AVG_SCORE_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	Wins = {
		NumColumns = 4,
		Title = "@LUA_MENU_WINS_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_WINS_AT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_WINS_LT",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_WINS_LT",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_WINS_CAPS",
			"@LUA_MENU_LOSSES_CAPS",
			"@LUA_MENU_RATIO_CAPS",
			"@LUA_MENU_STREAK_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	Kills = {
		NumColumns = 5,
		Title = "@LUA_MENU_KILLS_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_KILLS_AT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_KILLS_LT",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_KILLS_LT",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_DEATHS_CAPS",
			"@LUA_MENU_RATIO_CAPS",
			"@LUA_MENU_STREAK_CAPS",
			"@LUA_MENU_AVG_KILLS_CAPS"
		},
		ColumnWidths = {
			135,
			135,
			135,
			135,
			134
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	Accuracy = {
		NumColumns = 3,
		Title = "@LUA_MENU_ACCURACY_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ACCURACY_AT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ACCURACY_CAPS",
			"@LUA_MENU_HITS_CAPS",
			"@LUA_MENU_MISSES_CAPS"
		},
		ColumnWidths = {
			225,
			225,
			224
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	FreeForAll = {
		NumColumns = 4,
		Title = "@LUA_MENU_DEATHMATCH_CAPS",
		GameType = "dm",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_DM",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_DM",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_DM",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_DEATHS_CAPS",
			"@LUA_MENU_RATIO_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	TeamDeathmatch = {
		NumColumns = 5,
		Title = "@LUA_MENU_TEAM_DEATHMATCH_CAPS",
		GameType = "war",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_WAR",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_WAR",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_WAR",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_DEATHS_CAPS",
			"@LUA_MENU_RATIO_CAPS",
			"@LUA_MENU_ASSISTS_CAPS"
		},
		ColumnWidths = {
			135,
			135,
			135,
			135,
			134
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	GunGame = {
		NumColumns = 5,
		Title = "@LUA_MENU_GUN_CAPS",
		GameType = "gun",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_GUN",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_GUN",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_GUN",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_DEATHS_CAPS",
			"@LUA_MENU_RATIO_CAPS",
			"@LUA_MENU_MP_STABS_CAPS"
		},
		ColumnWidths = {
			135,
			135,
			135,
			135,
			134
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	SearchAndRescue = {
		NumColumns = 6,
		Title = "@LUA_MENU_SR_CAPS",
		GameType = "sr",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_SR",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_SR",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_SR",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_PLANTS_CAPS",
			"@LUA_MENU_DEFUSES_CAPS",
			"@LUA_MENU_DEFENDS_CAPS",
			"@LUA_MENU_RESCUES_CAPS",
			"@LUA_MENU_KILLS_CAPS"
		},
		ColumnWidths = {
			100,
			100,
			100,
			100,
			100,
			100
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8,
			9
		}
	},
	SearchAndDestroy = {
		NumColumns = 5,
		Title = "@LUA_MENU_SEARCH_AND_DESTROY_CAPS",
		GameType = "sd",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_SD",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_SD",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_SD",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_PLANTS_CAPS",
			"@LUA_MENU_DEFUSES_CAPS",
			"@LUA_MENU_DEFENDS_CAPS",
			"@LUA_MENU_KILLS_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	Domination = {
		NumColumns = 4,
		Title = "@LUA_MENU_DOMINATION_CAPS",
		GameType = "dom",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_DOM",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_DOM",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_DOM",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_CAPTURES_CAPS",
			"@LUA_MENU_DEFENDS_CAPS",
			"@LUA_MENU_KILLS_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	Blitz = {
		NumColumns = 5,
		Title = "@LUA_MENU_BLITZ_CAPS",
		GameType = "blitz",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_BLITZ",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_BLITZ",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_BLITZ",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_CAPTURES_CAPS",
			"@LUA_MENU_AVG_CAPTURES_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			172
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	KillConfirmed = {
		NumColumns = 4,
		Title = "@LUA_MENU_CONF_CAPS",
		GameType = "conf",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_CONF",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_CONF",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_CONF",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_CONFIRMS_CAPS",
			"@LUA_MENU_DENIES_CAPS",
			"@LUA_MENU_KILLS_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	Cranked = {
		NumColumns = 4,
		Title = "@LUA_MENU_CRANKED_CAPS",
		GameType = "cranked",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_CRANKED",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_CRANKED",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_CRANKED",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_KILL_CHAINS_CAPS",
			"@LUA_MENU_AVG_CHAINS_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	HuntedFFA = {
		NumColumns = 3,
		Title = "@LUA_MENU_SOTF_FFA_CAPS",
		GameType = "sotf_ffa",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_SOTF_FFA",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_SOTF_FFA",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_SOTF_FFA",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_KILLS_CAPS"
		},
		ColumnWidths = {
			225,
			225,
			224
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	Infected = {
		NumColumns = 4,
		Title = "@LUA_MENU_INFECT_CAPS",
		GameType = "infect",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_INFECT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_INFECT",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_INFECT",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_SURVIVOR_KILLS_CAPS",
			"@LUA_MENU_INFECTED_KILLS_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			170,
			170
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	DropZone = {
		NumColumns = 5,
		Title = "@MPUI_GRND_CAPS",
		GameType = "grnd",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_GRND",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_GRND",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_GRND",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_DEATHS_CAPS",
			"@LUA_MENU_RATIO_CAPS",
			"@LUA_MENU_ASSISTS_CAPS"
		},
		ColumnWidths = {
			135,
			135,
			135,
			135,
			134
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	Reinforce = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_SIEGE_CAPS",
		GameType = "siege",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_SIEGE",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_SIEGE",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_SIEGE",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_CAPTURES_CAPS",
			"@LUA_MENU_DEFENDS_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	SquadAssault = {
		NumColumns = 4,
		Title = "@LUA_MENU_SQUAD_ASSAULT_CAPS",
		GameType = "",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_SQUAD_ASSAULT",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_SQUAD_ASSAULT",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_SQUAD_ASSAULT",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_WINS_CAPS",
			"@LUA_MENU_LOSSES_CAPS",
			"@LUA_MENU_RATIO_CAPS"
		},
		ColumnWidths = {
			156,
			156,
			156,
			156
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	Safeguard = {
		NumColumns = 7,
		Title = "@LUA_MENU_HORDE_CAPS",
		GameType = "horde",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GM_HORDE",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GM_HORDE",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GM_HORDE",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_AVG_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@MENU_WAVES_CAPS",
			"@LUA_MENU_MAX_WAVE_CAPS",
			"@LUA_MENU_MAX_WEAPON_LEVEL_CAPS"
		},
		ColumnWidths = {
			94,
			75,
			105,
			94,
			80,
			115,
			94
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8,
			9,
			10
		}
	},
	AlienHives = {
		NumColumns = 3,
		Title = "@LUA_MENU_HIVES_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_HIVES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_HIVES",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_HIVES",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS"
		},
		ColumnWidths = {
			200,
			200,
			200
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	AlienKills = {
		NumColumns = 3,
		Title = "@LUA_MENU_KILLS_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_KILLS",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_KILLS",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_KILLS",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS"
		},
		ColumnWidths = {
			200,
			200,
			200
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	AlienRevives = {
		NumColumns = 5,
		Title = "@LUA_MENU_REVIVES_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_REVIVES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_REVIVES",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_REVIVES",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_REVIVES_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RATIO_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	AlienDowns = {
		NumColumns = 3,
		Title = "@LUA_MENU_DOWNED_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_DOWNED",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_DOWNED",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_DOWNED",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS"
		},
		ColumnWidths = {
			200,
			200,
			200
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	AlienScore = {
		NumColumns = 3,
		Title = "@LUA_MENU_SCORE_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_SCORE",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_SCORE",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_SCORE",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS"
		},
		ColumnWidths = {
			200,
			200,
			200
		},
		DataColumnIndexes = {
			4,
			5,
			6
		}
	},
	AlienChallenges = {
		NumColumns = 5,
		Title = "@LUA_MENU_CHALLENGES_COMPLETED_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_CHALLENGES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_CHALLENGES",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_CHALLENGES",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_COMPLETED_CAPS",
			"@LUA_MENU_ATTEMPTED_CAPS",
			"@LUA_MENU_PERCENT_COMPLETED_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_PER_GAME_CAPS"
		},
		ColumnWidths = {
			130,
			130,
			140,
			100,
			110
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	AlienCashFlow = {
		NumColumns = 4,
		Title = "@LUA_MENU_CASHFLOW_CAPS",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_CASHFLOW",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_CASHFLOW",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_CASHFLOW",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_CASH_EARNED_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS",
			"@LUA_MENU_CASH_SPENT_CAPS",
			"@LUA_MENU_SPEND_RATE_CAPS"
		},
		ColumnWidths = {
			150,
			150,
			150,
			150
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienTownSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_POC_SOLO_CAPS",
		MapName = "mp_alien_town",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_TOWN_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_TOWN_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_TOWN_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienTownCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_POC_COOP_CAPS",
		MapName = "mp_alien_town",
		isAlienCoop = true,
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_TOWN_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_TOWN_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_TOWN_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienTownEscapes = {
		NumColumns = 5,
		Title = "@LUA_MENU_POC_ESCAPES_CAPS",
		MapName = "mp_alien_town",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_TOWN_ESCAPES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ESCAPES_CAPS",
			"@LUA_MENU_PLATINUM_CAPS",
			"@LUA_MENU_GOLD_CAPS",
			"@LUA_MENU_SILVER_CAPS",
			"@LUA_MENU_BRONZE_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7,
			8
		}
	},
	AlienArmorySolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_NIGHTFALL_SOLO_CAPS",
		MapName = "mp_alien_armory",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_ARMORY_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_ARMORY_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_ARMORY_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienArmoryCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_NIGHTFALL_COOP_CAPS",
		MapName = "mp_alien_armory",
		isAlienCoop = true,
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_ARMORY_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_ARMORY_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_ARMORY_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienArmoryEscapes = {
		NumColumns = 5,
		Title = "@LUA_MENU_NIGHTFALL_ESCAPES_CAPS",
		MapName = "mp_alien_armory",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_ARMORY_ESCAPES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ESCAPES_CAPS",
			"@LUA_MENU_PLATINUM_CAPS",
			"@LUA_MENU_GOLD_CAPS",
			"@LUA_MENU_SILVER_CAPS",
			"@LUA_MENU_BRONZE_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			8,
			7,
			6,
			5
		}
	},
	AlienBeaconSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_MAYDAY_SOLO_CAPS",
		MapName = "mp_alien_beacon",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_BEACON_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_BEACON_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_BEACON_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienBeaconCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_MAYDAY_COOP_CAPS",
		MapName = "mp_alien_beacon",
		isAlienCoop = true,
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_BEACON_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_BEACON_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_BEACON_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_HIVES_DESTROYED_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienBeaconEscapes = {
		NumColumns = 5,
		Title = "@LUA_MENU_MP_LEADERBOARD_MAYDAY_ESCAPES_CAPS",
		MapName = "mp_alien_beacon",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_BEACON_ESCAPES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ESCAPES_CAPS",
			"@LUA_MENU_PLATINUM_CAPS",
			"@LUA_MENU_GOLD_CAPS",
			"@LUA_MENU_SILVER_CAPS",
			"@LUA_MENU_BRONZE_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			8,
			7,
			6,
			5
		}
	},
	AlienDlc3Solo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_DLC3_SOLO_CAPS",
		MapName = "mp_alien_dlc3",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_DLC3_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_DLC3_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_DLC3_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_MP_OBELISKS_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienDlc3Coop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_DLC3_COOP_CAPS",
		MapName = "mp_alien_dlc3",
		isAlienCoop = true,
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_DLC3_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_DLC3_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_DLC3_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_MP_OBELISKS_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienDlc3Escapes = {
		NumColumns = 5,
		Title = "@LUA_MENU_MP_LEADERBOARD_DLC3_ESCAPES_CAPS",
		MapName = "mp_alien_dlc3",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_DLC3_ESCAPES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ESCAPES_CAPS",
			"@LUA_MENU_PLATINUM_CAPS",
			"@LUA_MENU_GOLD_CAPS",
			"@LUA_MENU_SILVER_CAPS",
			"@LUA_MENU_BRONZE_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			8,
			7,
			6,
			5
		}
	},
	AlienLastSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_LAST_SOLO_CAPS",
		MapName = "mp_alien_last",
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_LAST_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_LAST_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_LAST_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_MP_GENERATORS_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienLastCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_LAST_COOP_CAPS",
		MapName = "mp_alien_last",
		isAlienCoop = true,
		HasHardcoreMode = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_LAST_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_LAST_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_LAST_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_MP_GENERATORS_CAPS",
			"@LUA_MENU_DOWNED_CAPS",
			"@LUA_MENU_RELICS_USED_CAPS"
		},
		ColumnWidths = {
			140,
			180,
			140,
			140
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienLastEscapes = {
		NumColumns = 5,
		Title = "@LUA_MENU_MP_LEADERBOARD_LAST_ESCAPES_CAPS",
		MapName = "mp_alien_last",
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_LAST_ESCAPES",
				DurationDef = Leaderboards.DurationDefs.Alltime
			}
		},
		HeaderNames = {
			"@LUA_MENU_ESCAPES_CAPS",
			"@LUA_MENU_PLATINUM_CAPS",
			"@LUA_MENU_GOLD_CAPS",
			"@LUA_MENU_SILVER_CAPS",
			"@LUA_MENU_BRONZE_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			8,
			7,
			6,
			5
		}
	},
	AlienChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_CHAOS_SOLO_CAPS",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_AVG_KILLS_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_CHAOS_COOP_CAPS",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_GB_ALIEN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_GB_ALIEN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_GB_ALIEN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_GAMES_CAPS",
			"@LUA_MENU_AVG_KILLS_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienTownChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_POC_SOLO_CAPS",
		MapName = "mp_alien_town",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienTownChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_POC_COOP_CAPS",
		MapName = "mp_alien_town",
		chaos = true,
		isAlienCoop = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_TOWN_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienArmoryChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_NIGHTFALL_SOLO_CAPS",
		MapName = "mp_alien_armory",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienArmoryChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_NIGHTFALL_COOP_CAPS",
		MapName = "mp_alien_armory",
		chaos = true,
		isAlienCoop = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_ARMORY_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienBeaconChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_MAYDAY_SOLO_CAPS",
		MapName = "mp_alien_beacon",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienBeaconChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_MAYDAY_COOP_CAPS",
		MapName = "mp_alien_beacon",
		chaos = true,
		isAlienCoop = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_BEACON_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienDlc3ChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_DLC3_SOLO_CAPS",
		MapName = "mp_alien_dlc3",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienDlc3ChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_DLC3_COOP_CAPS",
		MapName = "mp_alien_dlc3",
		chaos = true,
		isAlienCoop = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_DLC3_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienLastChaosSolo = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_LAST_SOLO_CAPS",
		MapName = "mp_alien_last",
		chaos = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_LAST_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_LAST_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_LAST_CHAOS_SOLO",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	},
	AlienLastChaosCoop = {
		NumColumns = 4,
		Title = "@LUA_MENU_MP_LEADERBOARD_LAST_COOP_CAPS",
		MapName = "mp_alien_last",
		chaos = true,
		isAlienCoop = true,
		DefaultDurationKey = "Alltime",
		Durations = {
			Alltime = {
				File = "LB_MP_ALIEN_LAST_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Alltime
			},
			Weekly = {
				File = "LB_MP_ALIEN_LAST_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Weekly
			},
			Monthly = {
				File = "LB_MP_ALIEN_LAST_CHAOS_COOP",
				DurationDef = Leaderboards.DurationDefs.Monthly
			}
		},
		HeaderNames = {
			"@LUA_MENU_SCORE_CAPS",
			"@LUA_MENU_KILLS_CAPS",
			"@LUA_MENU_MP_COMBO_CAPS",
			"@LUA_MENU_TIME_PLAYED_CAPS"
		},
		ColumnWidths = {
			125,
			125,
			125,
			125
		},
		DataColumnIndexes = {
			4,
			5,
			6,
			7
		}
	}
}
Leaderboards.OpenLeaderboard = function ( f1_arg0, f1_arg1, f1_arg2, f1_arg3, f1_arg4 )
	Engine.SetDvarString( "lb_filter", Leaderboards.GetLeaderboardFilterValue( f1_arg2 ) )
	local f1_local0 = LUI.FlowManager.GetMenuScopedDataByMenuName( "mp_leaderboard_main" )
	f1_local0.filterDurationKey = f1_arg3
	f1_local0.isHardcore = f1_arg4
	f1_arg0:dispatchEventToRoot( {
		name = "aar_set_subtitle_text",
		new_text = Engine.Localize( Leaderboards.GetLeaderboardFilterTitle( f1_arg2 ), Engine.Localize( Leaderboards.GetLeaderboardTitle( f1_arg1 ) ) )
	} )
	local f1_local1 = f1_arg0.properties.exclusiveController
	if not f1_local1 then
		f1_local1 = Engine.GetFirstActiveController()
	end
	local f1_local2 = Leaderboards.GetLeaderboardDurationDef( f1_arg1, f1_arg3 )
	Leaderboards.Open( Leaderboards.GetLeaderboardDurationFile( f1_arg1, f1_arg3, f1_arg4 ), f1_local2.Duration )
	Leaderboards.UpdateLeaderboard( f1_local1, Leaderboards.GetCurrentIndex( f1_local1 ) )
end

Leaderboards.LeaderboardFilterGetDurationKeys = function ( f2_arg0 )
	local f2_local0 = {}
	for f2_local4, f2_local5 in pairs( Leaderboards.Boards[f2_arg0].Durations ) do
		f2_local0[#f2_local0 + 1] = f2_local4
	end
	return f2_local0
end

Leaderboards.GetLeaderboardTitle = function ( f3_arg0 )
	return Leaderboards.Boards[f3_arg0].Title
end

Leaderboards.GetLeaderboardNumColumns = function ( f4_arg0 )
	return Leaderboards.Boards[f4_arg0].NumColumns
end

Leaderboards.GetLeaderboardDefaultDurationKey = function ( f5_arg0 )
	return Leaderboards.Boards[f5_arg0].DefaultDurationKey
end

Leaderboards.GetLeaderboardHasHardcoreMode = function ( f6_arg0 )
	return Leaderboards.Boards[f6_arg0].HasHardcoreMode
end

Leaderboards.GetLeaderboardHeaderName = function ( f7_arg0, f7_arg1 )
	return Leaderboards.Boards[f7_arg0].HeaderNames[f7_arg1]
end

Leaderboards.GetLeaderboardColumnWidth = function ( f8_arg0, f8_arg1 )
	return Leaderboards.Boards[f8_arg0].ColumnWidths[f8_arg1]
end

Leaderboards.GetLeaderboardDataColumnIndex = function ( f9_arg0, f9_arg1 )
	return Leaderboards.Boards[f9_arg0].DataColumnIndexes[f9_arg1]
end

Leaderboards.GetLeaderboardDurationFile = function ( f10_arg0, f10_arg1, f10_arg2 )
	local f10_local0 = Leaderboards.Boards[f10_arg0].Durations[f10_arg1].File
	if f10_arg2 then
		f10_local0 = f10_local0 .. "_HC"
	end
	return f10_local0
end

Leaderboards.GetLeaderboardDurationDef = function ( f11_arg0, f11_arg1 )
	return Leaderboards.Boards[f11_arg0].Durations[f11_arg1].DurationDef
end

Leaderboards.GetLeaderboardByGameType = function ( f12_arg0 )
	local f12_local0 = nil
	for f12_local4, f12_local5 in pairs( Leaderboards.Boards ) do
		if f12_local5.GameType ~= nil and f12_local5.GameType == f12_arg0 then
			f12_local0 = f12_local4
		end
	end
	return f12_local0
end

Leaderboards.GetAlienCoopLeaderboardByMapName = function ( f13_arg0 )
	local f13_local0 = LUI.mp_menus.Aliens.IsChaosEnabled()
	local f13_local1 = nil
	for f13_local5, f13_local6 in pairs( Leaderboards.Boards ) do
		if f13_local6.isAlienCoop and (not (f13_local0 or f13_local6.chaos) or f13_local0 and f13_local6.chaos) and f13_local6.MapName ~= nil and f13_local6.MapName == f13_arg0 then
			f13_local1 = f13_local5
		end
	end
	return f13_local1
end

Leaderboards.GetLeaderboardFilterTitle = function ( f14_arg0 )
	return Leaderboards.Filters[f14_arg0].Title
end

Leaderboards.GetLeaderboardFilterOptionText = function ( f15_arg0 )
	return Leaderboards.Filters[f15_arg0].OptionText
end

Leaderboards.GetLeaderboardFilterValue = function ( f16_arg0 )
	return Leaderboards.Filters[f16_arg0].Value
end

