DebugPrint( "Running main.lua" )
require( "LUI.CoD" )
require( "LUI.mp_menus.MenuData" )
require( "LUI.MenuGenerics" )
require( "LUI.MenuGenericButtons" )
require( "LUI.common_menus.CommonPopups" )
require( "LUI.ButtonHelperText" )
if Engine.HasSpeechFeature() then
	require( "LUI.MenuAutoNav" )
	require( "LUI.Speech" )
	require( "LUI.common_menus.KinectControlMenu" )
	require( "LUI.common_menus.KinectUtils" )
	require( "LUI.common_menus.WhatCanISay" )
end
if Engine.InFrontend() then
	require( "LUI.mp_menus.CacCustomize" )
end
require( "LUI.common_menus.RankUtils" )
require( "LUI.common_menus.CacUtils" )
require( "LUI.common_menus.CacCustomizeUtils" )
require( "LUI.mp_menus.CacLoadoutUtils" )
require( "LUI.mp_menus.PlayerDataInit" )
if Engine.InFrontend() or Engine.IsAliensMode() then
	require( "LUI.mp_menus.Aliens" )
	require( "LUI.mp_menus.AliensPurchasables" )
end
require( "LUI.common_menus.OptionsLayout" )
require( "LUI.common_menus.Options" )
require( "LUI.mp_menus.CacRecap" )
require( "LUI.common_menus.FriendsWidget" )
require( "LUI.common_menus.FriendsList" )
require( "LUI.common_menus.FriendsListUtils" )
require( "LUI.mp_menus.MPLobbyUtils" )
if Engine.InFrontend() then
	require( "LUI.PersistentBackground" )
	require( "LUI.mp_menus.MLGUtils" )
	require( "LUI.mp_menus.SvSUtils" )
	require( "LUI.mp_menus.AliensIntel" )
	require( "LUI.mp_menus.AliensLoadout" )
	require( "LUI.ButtonDescText" )
	require( "LUI.common_menus.GameManual" )
	require( "LUI.common_menus.ProfilePopup" )
	require( "LUI.common_menus.PlayerCard" )
	require( "LUI.common_menus.VirtualKeyboard" )
	require( "LUI.mp_menus.AARUtils" )
	require( "LUI.mp_menus.AARUnlockScreen" )
	require( "LUI.mp_menus.AARCommon" )
	require( "LUI.mp_menus.AARSummary" )
	require( "LUI.mp_menus.AARMain" )
	require( "LUI.mp_menus.AARMini" )
	require( "LUI.mp_menus.CacMain" )
	require( "LUI.mp_menus.CacEdit" )
	require( "LUI.mp_menus.CacEditSelectionInfo" )
	require( "LUI.mp_menus.CacEditPopup" )
	require( "LUI.mp_menus.CacEditChooseImagePopup" )
	require( "LUI.mp_menus.CacEditWeaponAttachChoose" )
	require( "LUI.mp_menus.CacEditWeaponStatsInfoPane" )
	require( "LUI.mp_menus.CacEditWeaponPerformanceInfoPane" )
	require( "LUI.mp_menus.CacInfoPanes" )
	require( "LUI.mp_menus.CacAbilitiesAlt" )
	require( "LUI.mp_menus.CacMemberSelect" )
	require( "LUI.mp_menus.CacPrestigeDetails" )
	require( "LUI.mp_menus.MPPlaylist" )
	require( "LUI.mp_menus.MPPopups" )
	require( "LUI.mp_menus.MPLobbySearchWidget" )
	require( "LUI.mp_menus.mpLobbyWidgets" )
	require( "LUI.mp_menus.MPLobbyNavigation" )
	require( "LUI.mp_menus.MPLobbyCharacterView" )
	require( "LUI.mp_menus.MPLobbyPlayerStats" )
	require( "LUI.mp_menus.MPMainMenu" )
	require( "LUI.mp_menus.MPXboxLiveMenu" )
	require( "LUI.mp_menus.SystemLinkMenu" )
	require( "LUI.mp_menus.SystemLinkJoinMenu" )
	require( "LUI.mp_menus.SystemLinkGameSetupMenu" )
	require( "LUI.mp_menus.SplitScreenGameSetupMenu" )
	require( "LUI.mp_menus.MPPlayerPopups" )
	require( "LUI.mp_menus.MPLivePrivateLobby" )
	require( "LUI.mp_menus.MPLivePublicLobby" )
	require( "LUI.mp_menus.SplitScreenSignIn" )
	require( "LUI.mp_menus.MPBarracks" )
	require( "LUI.mp_menus.MPCoDAnywhere" )
	require( "LUI.mp_menus.MPCustomClassRestrictions" )
	require( "LUI.mp_menus.MPMemberList" )
	require( "LUI.mp_menus.MPGameModeSelectMenu" )
	require( "LUI.mp_menus.MPGameSetupMenu" )
	require( "LUI.mp_menus.MPGameSetupModeMenu" )
	require( "LUI.mp_menus.MPGameSetupOptionsMenu" )
	require( "LUI.mp_menus.MPLeaderboard" )
	require( "LUI.mp_menus.MPLeaderboardPopups" )
	require( "LUI.mp_menus.MPPrestigeReset" )
	require( "LUI.mp_menus.MPStatsReset" )
	require( "LUI.mp_menus.AARScoreboard" )
	require( "LUI.mp_menus.AAROperationProgress" )
	require( "LUI.mp_menus.KillstreakSelections" )
	require( "LUI.mp_menus.SquadPrePartyLobby" )
	require( "LUI.mp_menus.Leaderboards" )
	require( "LUI.mp_menus.LeaderboardUtils" )
	require( "LUI.mp_menus.MPMapSetupMenu" )
	require( "LUI.mp_menus.MPSavedModeSelectMenu" )
	require( "LUI.mp_menus.LUISquadMemberWindow" )
	require( "LUI.mp_menus.Operations" )
	require( "LUI.mp_menus.OperationsUtils" )
	require( "LUI.mp_menus.ClanElements" )
	require( "LUI.mp_menus.ClanInvites" )
	require( "LUI.mp_menus.ClanDetails" )
	require( "LUI.BootScreenMargins" )
	require( "LUI.mp_menus.ChooseCoDAnywherePlatform" )
	require( "LUI.mp_menus.SnsUtils" )
	require( "LUI.mp_menus.SnsElements" )
	require( "LUI.mp_menus.Store" )
	require( "LUI.mp_menus.SquadReports" )
	require( "LUI.mp_menus.SquadReportDetail" )
	require( "LUI.mp_menus.ArchetypeSelect" )
	require( "LUI.mp_menus.AARSquadSummary" )
	require( "LUI.mp_menus.SquadsModeSelect" )
	require( "LUI.mp_menus.MOTDWidgets" )
	require( "LUI.mp_menus.MOTDUtils" )
	require( "LUI.mp_menus.SocialFeed" )
	require( "LUI.mp_menus.LoadoutBuilder" )
	if not Engine.IsConsoleGame() then
		require( "LUI.PCOptions" )
		require( "LUI.AdvancedVideo" )
		require( "LUI.MovementControls" )
		require( "LUI.ActionsControls" )
		require( "LUI.ChatControls" )
		require( "LUI.GamepadControls" )
		require( "LUI.LookControls" )
	end
	require( "LUI.luitest" )
end
if not Engine.InFrontend() then
	local f0_local0 = Engine.GetDvarString( "ui_gametype" )
	local f0_local1 = Engine.GetDvarString( "ui_mapname" )
	require( "LUI.mp_hud.MLGHud" )
	require( "LUI.mp_hud.OptionsMenu" )
	require( "LUI.mp_hud.endGameMenu" )
	require( "LUI.mp_hud.DamageFeedbackHud" )
	require( "LUI.mp_hud.GameMessageHud" )
	require( "LUI.mp_hud.ScreenEffectsHud" )
	require( "LUI.mp_hud.Hints" )
	require( "LUI.mp_hud.PredatorMissileOverlayHud" )
	require( "LUI.mp_hud.MatchStartHud" )
	require( "LUI.mp_hud.MutePlayers" )
	require( "LUI.mp_hud.HostMigration" )
	require( "LUI.mp_hud.VanguardOverlayHud" )
	require( "LUI.mp_hud.WeaponAttachment" )
	require( "LUI.mp_hud.TalkerHud" )
	if Engine.IsPS4() then
		require( "LUI.common_menus.VitaHud" )
	end
	if Engine.IsAliensMode() then
		require( "LUI.mp_hud.AlienHud" )
		require( "LUI.mp_hud.AlienHudTechTree" )
		require( "LUI.mp_hud.AlienScoreboards" )
		require( "LUI.mp_hud.AlienCapturingHud" )
		require( "LUI.mp_hud.AlienChaos" )
		require( "LUI.mp_hud.AlienVanguardOverlayHud" )
	else
		require( "LUI.mp_hud.hudUtils" )
		require( "LUI.mp_hud.hud" )
		if CoD.IsFireTeamMode() then
			require( "LUI.mp_hud.FireTeamMenu" )
		end
		require( "LUI.mp_hud.PlayerCardHud" )
		require( "LUI.mp_hud.PointsPopupHud" )
		require( "LUI.mp_hud.TimersHud" )
		require( "LUI.mp_hud.ScorelistHud" )
		require( "LUI.mp_hud.Scoreboard" )
		require( "LUI.mp_hud.WeaponInfoHud" )
		require( "LUI.mp_hud.PlayerInfoHud" )
		require( "LUI.mp_hud.MinimapHud" )
		require( "LUI.mp_hud.jammerEffectHud" )
		require( "LUI.mp_hud.TeamScoresHud" )
		require( "LUI.mp_hud.KillstreakHud" )
		require( "LUI.mp_hud.SplashesHud" )
		require( "LUI.mp_hud.CapturingHud" )
		if f0_local0 == "horde" then
			require( "LUI.mp_hud.HordeHud" )
			require( "LUI.mp_hud.HordePerksHud" )
		end
		require( "LUI.mp_hud.IntelChallenges" )
		require( "LUI.mp_hud.KillCamHud" )
		require( "LUI.mp_hud.OverlayHud" )
		require( "LUI.mp_hud.CharSelectMenu" )
		require( "LUI.mp_hud.TeamSelect" )
		require( "LUI.mp_hud.ObituaryHud" )
		require( "LUI.mp_hud.SpectatorHud" )
		require( "LUI.mp_hud.OptionsMenuScoreboard" )
		require( "LUI.mp_hud.HelicopterPilotOverlayHud" )
		require( "LUI.mp_hud.OdinOverlayHud" )
		require( "LUI.mp_hud.JuggernautOverlayHud" )
		require( "LUI.mp_hud.A10OverlayHud" )
		require( "LUI.mp_hud.PerksOnSpawnHud" )
		require( "LUI.mp_hud.RoundEndHud" )
		if f0_local1 == "mp_battery3" then
			require( "LUI.mp_hud.PredatorOverlayHud2" )
		end
		if f0_local1 == "mp_favela_iw6" then
			require( "LUI.mp_hud.AC130OverlayHud" )
		end
		if f0_local1 == "mp_dig" then
			require( "LUI.mp_hud.DigHud" )
		end
	end
	if not Engine.IsConsoleGame() then
		require( "LUI.mp_hud.inGamePCOptions" )
		require( "LUI.mp_hud.inGameAdvancedVideo" )
		require( "LUI.mp_hud.inGameMovementControls" )
		require( "LUI.mp_hud.inGameActionsControls" )
		require( "LUI.mp_hud.inGameChatControls" )
		require( "LUI.mp_hud.inGameGamepadControls" )
		require( "LUI.mp_hud.inGameLookControls" )
	else
		require( "LUI.mp_hud.inGameControls" )
	end
end
DisableGlobals()
