local f0_local0 = module
local f0_local1, f0_local2 = ...
f0_local0( f0_local1, package.seeall )
CoD.PrintModuleLoad( _NAME )
function OnCreate( f1_arg0, f1_arg1 )
	f1_arg0:processEvent( {
		name = "add_button_helper_text",
		button_ref = "button_secondary",
		helper_text = Engine.Localize( "@LUA_MENU_BACK" ),
		side = "left",
		clickable = true
	} )
	f1_arg0:processEvent( {
		name = "add_button_helper_text",
		button_ref = "button_alt2",
		helper_text = Engine.Localize( "@MENU_FRIENDS" ),
		side = "right",
		clickable = true
	} )
end

function OnlineVaultAction( f2_arg0, f2_arg1 )
	LUI.FlowManager.RequestAddMenu( f2_arg0, "online_vault_main", true, f2_arg1.controller, false, {
		vaultMode = "browse",
		vaultCategory = "all",
		menu_title = Engine.Localize( "@MPUI_ONLINE_VAULT" )
	} )
end

function FriendVaultAction( f3_arg0, f3_arg1 )
	
end

function TheaterAction( f4_arg0, f4_arg1 )
	
end

function ButtonFeeder( f5_arg0 )
	return {
		{
			type = "UIGenericButton",
			id = "vault_button_0",
			properties = {
				button_text = Engine.Localize( "@MENU_ONLINEVAULT_CAPS" ),
				button_action_func = OnlineVaultAction
			}
		},
		{
			type = "UIGenericButton",
			id = "vault_button_1",
			properties = {
				button_text = Engine.Localize( "@MENU_FRIENDS_ONLINEVAULT_CAPS" ),
				button_action_func = FriendVaultAction
			}
		},
		{
			type = "UIGenericButton",
			id = "vault_button_2",
			properties = {
				button_text = Engine.Localize( "@MENU_THEATRE_CAPS" ),
				button_action_func = TheaterAction
			}
		}
	}
end

function vault_main()
	return {
		type = "UIElement",
		id = "vault_root",
		properties = {
			menu_title = Engine.Localize( "@MENU_VAULT_CAPS" )
		},
		states = {
			default = {
				topAnchor = true,
				bottomAnchor = true,
				leftAnchor = true,
				rightAnchor = true,
				top = 0,
				bottom = 0,
				left = 0,
				right = 0
			}
		},
		handlers = {
			menu_create = OnCreate
		},
		children = {
			{
				type = "generic_menu_title",
				id = "vault_title_id",
				properties = {
					menu_title = MBh.Property( "menu_title" )
				}
			},
			{
				type = "UIVerticalList",
				id = "vault_entry_vlist_id",
				focusable = true,
				states = {
					default = {
						alignment = LUI.Alignment.Top,
						leftAnchor = true,
						rightAnchor = false,
						topAnchor = true,
						bottomAnchor = false,
						left = GenericMenuDims.menu_left,
						right = GenericMenuDims.menu_right,
						top = GenericMenuDims.menu_top,
						bottom = GenericMenuDims.menu_bottom
					}
				},
				handlers = {
					vault_refresh = DoRefresh
				},
				childrenFeeder = ButtonFeeder
			},
			{
				type = "online_friends_widget",
				id = "vault_friends_widget_id"
			},
			{
				type = "button_helper_text_main",
				id = "vault_helper_text_id"
			},
			{
				type = "generic_back_button",
				id = "vault_bind_button_id"
			}
		}
	}
end

LUI.MenuBuilder.registerDef( "vault_main", vault_main )
LockTable( _M )
